<script>
    let id = 0;
    let campaignFormat = "S";
    let concept = "";
    let variation = "";
    let collage = "C";
    let photo = "F";
    let geo = "";
    let gender = "M";
    let ageFrom = 0;
    let ageTo = 0;
    let isIOS = false;
    let isAndroid = false;
    let isDesktop = false;
    let social = "F";
    let language = "Eng";
    let result = "";
    let alertIsVisible = false;

    function calculate() {
        result = `${id}_${campaignFormat}_${abbreviation(concept)}|${abbreviation(variation)}${collage}${photo}_${geo}_${gender}${ageFrom}${ageTo}_`

	    if (isIOS) {
            result += "I";
	    }

        if (isAndroid) {
            result += "A";
        }

        if (isDesktop) {
            result += "D";
        }

        result += `_${social}_${language}`;
        alertIsVisible = true;
    }

    function abbreviation(words) {
        if (!words) {
            return "";
        }

        let abbr = "";

        for (let w of words.split(" ")) {
            abbr += w.charAt(0).toUpperCase();
        }

        return abbr;
    }

    function clear() {
        id = 0;
        campaignFormat = "S";
        concept = "";
        variation = "";
        collage = "C";
        photo = "F";
        geo = "";
        gender = "M";
        ageFrom = 0;
        ageTo = 0;
        isIOS = false;
        isAndroid = false;
        isDesktop = false;
        social = "F";
        language = "Eng";
        result = "";
        alertIsVisible = false;
    }
</script>

<style>
	.top-margin {
		margin-top: 50px;
	}

	.device {
		margin-right: 24px;
	}
</style>

<main class="container top-margin">
	<form>
		<fieldset>
			<label for="nameField">ID</label>
			<input type="number" placeholder="123" id="nameField" bind:value={id}>

			<label for="campaign-format">Campaign Format</label>
			<select id="campaign-format" bind:value={campaignFormat}>
				<option value="S">Scaling</option>
				<option value="T">Test</option>
			</select>

			<label for="concept">Concept</label>
			<input type="text" placeholder="Calendar weekly" id="concept" bind:value={concept}>

			<label for="variation">Variation</label>
			<input type="text" placeholder="photo fone" id="variation" bind:value={variation}>

			<label for="col-sin">Collage/Single</label>
			<select id="col-sin" bind:value={collage}>
				<option value="C">Collage</option>
				<option value="S">Single</option>
			</select>

			<label for="photo">Photo/Illustration</label>
			<select id="photo" bind:value={photo}>
				<option value="F">Photo</option>
				<option value="I">Illustration</option>
			</select>

			<label for="geo">Geo</label>
			<input type="text" placeholder="US" id="geo" bind:value={geo}>

			<label for="gender">Gender</label>
			<select id="gender" bind:value={gender}>
				<option value="M">Male</option>
				<option value="F">Female</option>
				<option value="MF">Male+Female</option>
			</select>

			<label for="age-from">Age from</label>
			<input type="number" placeholder="13" id="age-from" bind:value={ageFrom}>

			<label for="age-to">Age to</label>
			<input type="number" placeholder="99" id="age-to" bind:value={ageTo}>

			<label>Devices</label>
			<div class="device">
				<label class="label-inline" for="ios">iOS</label>
				<input type="checkbox" id="ios" bind:value={isIOS}>
			</div>

			<div class="device">
				<label class="label-inline" for="android">Android</label>
				<input type="checkbox" id="android" bind:value={isAndroid}>
			</div>

			<div class="device">
				<label class="label-inline" for="desktop">Desktop</label>
				<input type="checkbox" id="desktop" bind:value={isDesktop}>
			</div>

			<label for="platform">Platform</label>
			<select id="platform" bind:value={social}>
				<option value="F">FB</option>
				<option value="I">Instagram</option>
				<option value="All">All</option>
			</select>

			<label for="lang">Language</label>
			<select id="lang" bind:value={language}>
				<option value="Eng">English</option>
				<option value="No">No</option>
			</select>
		</fieldset>
	</form>

	<div class="row">
		<button class="button" on:click={calculate}>Generate</button>
		<button class="button button-clear" on:click={clear}>Clear</button>

		{#if alertIsVisible}
			<p>{result}</p>
		{/if}
	</div>
</main>